"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var ReactDom = require("react-dom");
var root_1 = require("react-hot-loader/root");
var react_router_dom_1 = require("react-router-dom");
var provider_1 = require("./provider");
var Bootstrap = /** @class */ (function (_super) {
    __extends(Bootstrap, _super);
    function Bootstrap() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Bootstrap.prototype.render = function () {
        var _this = this;
        return this.props.data.template.name === "404" ? (React.createElement(this.props.templates.notFound, __assign({}, this.props))) : (React.createElement(react_router_dom_1.BrowserRouter, null,
            React.createElement(react_router_dom_1.Switch, null,
                React.createElement(react_router_dom_1.Route, { exact: true, path: "/", render: function (props) { return (React.createElement(_this.props.templates.home, __assign({}, props, _this.props))); } }),
                React.createElement(react_router_dom_1.Route, { exact: true, path: "/collections", render: function (props) { return (React.createElement(_this.props.templates.collections, __assign({}, props, _this.props))); } }),
                React.createElement(react_router_dom_1.Route, { exact: true, path: "/collections/:collection", render: function (props) { return (React.createElement(_this.props.templates.collection, __assign({}, props, _this.props))); } }),
                React.createElement(react_router_dom_1.Route, { exact: true, path: "/collections/:collection/:tag", render: function (props) { return (React.createElement(_this.props.templates.collection, __assign({}, props, _this.props))); } }),
                React.createElement(react_router_dom_1.Route, { exact: true, path: "/products/:productId", render: function (props) { return (React.createElement(_this.props.templates.product, __assign({}, props, _this.props))); } }),
                React.createElement(react_router_dom_1.Route, { exact: true, path: "/collections/:collection/products/:productId", render: function (props) { return (React.createElement(_this.props.templates.product, __assign({}, props, _this.props))); } }),
                React.createElement(react_router_dom_1.Route, { exact: true, path: "/search", render: function (props) { return (React.createElement(_this.props.templates.search, __assign({}, props, _this.props))); } }),
                React.createElement(react_router_dom_1.Route, { exact: true, path: "/cart", render: function (props) { return (React.createElement(_this.props.templates.cart, __assign({}, props, _this.props))); } }),
                React.createElement(react_router_dom_1.Route, { exact: true, path: "/challenge", render: function (props) { return (React.createElement(_this.props.templates.challenge, __assign({}, props, _this.props))); } }),
                React.createElement(react_router_dom_1.Route, { exact: true, path: "/checkout", render: function (props) { return (React.createElement(_this.props.templates.checkout, __assign({}, props, _this.props))); } }),
                React.createElement(react_router_dom_1.Route, { exact: true, path: "/pages/:page", render: function (props) { return (React.createElement(_this.props.templates.page, __assign({}, props, _this.props))); } }),
                React.createElement(react_router_dom_1.Route, { exact: true, path: "/policies/:policy", render: function (props) { return (React.createElement(_this.props.templates.policy, __assign({}, props, _this.props))); } }),
                React.createElement(react_router_dom_1.Route, { exact: true, path: "/blogs/:blog", render: function (props) { return (React.createElement(_this.props.templates.blog, __assign({}, props, _this.props))); } }),
                React.createElement(react_router_dom_1.Route, { exact: true, path: "/blogs/:blog/tagged/:tag", render: function (props) { return (React.createElement(_this.props.templates.blog, __assign({}, props, _this.props))); } }),
                React.createElement(react_router_dom_1.Route, { exact: true, path: "/blogs/:blog/:article", render: function (props) { return (React.createElement(_this.props.templates.article, __assign({}, props, _this.props))); } }),
                React.createElement(react_router_dom_1.Route, { exact: true, path: "/account", render: function (props) { return (React.createElement(_this.props.templates.account.details, __assign({}, props, _this.props))); } }),
                React.createElement(react_router_dom_1.Route, { exact: true, path: "/account/login", render: function (props) { return (React.createElement(_this.props.templates.account.login, __assign({}, props, _this.props))); } }),
                React.createElement(react_router_dom_1.Route, { exact: true, path: "/account/register", render: function (props) { return (React.createElement(_this.props.templates.account.register, __assign({}, props, _this.props))); } }),
                React.createElement(react_router_dom_1.Route, { exact: true, path: "/account/addresses", render: function (props) { return (React.createElement(_this.props.templates.account.addresses, __assign({}, props, _this.props))); } }),
                React.createElement(react_router_dom_1.Route, { exact: true, path: "/account/orders/:orderId", render: function (props) { return (React.createElement(_this.props.templates.account.order, __assign({}, props, _this.props))); } }),
                React.createElement(react_router_dom_1.Route, { exact: true, path: "/account/reset/:id/:token", render: function (props) { return (React.createElement(_this.props.templates.account.reset, __assign({}, props, _this.props))); } }),
                React.createElement(react_router_dom_1.Route, { exact: true, path: "/account/activate/:id/:token", render: function (props) { return (React.createElement(_this.props.templates.account.activate, __assign({}, props, _this.props))); } }),
                React.createElement(react_router_dom_1.Route, { exact: true, path: "/account/invalid_token", render: function (props) { return (React.createElement(_this.props.templates.account.activate, __assign({}, props, _this.props))); } }),
                React.createElement(react_router_dom_1.Route, { exact: true, path: "/account/logout", render: function (props) { return (React.createElement(_this.props.templates.account.logout, __assign({}, props, _this.props))); } }),
                React.createElement(react_router_dom_1.Route, { exact: true, path: "/gift_cards/:id/:token", render: function (props) { return (React.createElement(_this.props.templates.giftcard, __assign({}, props, _this.props))); } }),
                React.createElement(react_router_dom_1.Route, { exact: true, path: "/apps/toolkit/wishlist/:id", render: function (props) { return (React.createElement(_this.props.templates.wishlist, __assign({}, props, _this.props))); } }),
                React.createElement(react_router_dom_1.Route, { exact: true, path: "/password", render: function (props) { return (React.createElement(_this.props.templates.password, __assign({}, props, _this.props))); } }),
                React.createElement(react_router_dom_1.Route, { exact: true, path: "/a/:app", render: null }),
                React.createElement(react_router_dom_1.Route, { render: function (props) { return (React.createElement(_this.props.templates.notFound, __assign({}, props, _this.props))); } }))));
    };
    Bootstrap.bootstrap = function (element, templates, sections, data) {
        root_1.hot(ReactDom.render(React.createElement(provider_1.ThemeProvider, { value: { cart: null, error: null } },
            React.createElement(Bootstrap, { templates: templates, sections: sections, data: data })), document.getElementById(element)));
    };
    Bootstrap.element = function (templates, sections, data) {
        return React.createElement(Bootstrap, { templates: templates, sections: sections, data: data });
    };
    return Bootstrap;
}(React.Component));
exports.Bootstrap = Bootstrap;
//# sourceMappingURL=bootstrap.js.map